
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    //float3 color : DIFFUSE;
    float4 diffuse : DIFFUSE;
    float2 uvs :TEXCOORD0;
    float3 tangent :TEXCOORD1;
    //
	//float3 TestColor : SPECULAR;
};





struct vfconn
{

    float4 HPOS : POSITION;
    //oat4 Nrm : NORMAL;
	float4 HCOL : COLOR;
	float4 HCOL2 : COLOR1;
    float4 oPosition : TEXCOORD1;
    float2 oUV : TEXCOORD0;
    float3 oNormal : TEXCOORD3;
    float3 oHalf : TEXCOORD4;
    float3 oLight : TEXCOORD2;
  
};








vfconn main(appdata IN,
                uniform float3 LightPos,
                uniform float3 CameraPos,
          uniform float3 Reduction,
uniform float3 alpha,
uniform float4x4 ModelViewLightProj,
uniform float4x4 ModelViewObject,
			uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    
//
	//ModelViewProj=mul(ModelViewProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewLightProj,ModelViewObject);
    //ModelViewLightProj=mul(ModelViewObject,ModelViewLightProj);
    
   
    IN.position=mul(ModelViewObject,IN.position);
/*
float fx=max (0,3-IN.position.y)*1.7;
fx=min (1,fx);
if (IN.position.y>-1) { 
if (IN.position.x>2.3) IN.position.z+=alpha.x*fx;
if (IN.position.x<-2.3) IN.position.z+=alpha.y*fx;
}

float fx2=max (0,-3-IN.position.y)*1.7;
fx2=min (1,fx2)*0.7;

if (IN.position.y<-3) { 
if (IN.position.x>0.3) IN.position.z+=fx2*alpha.y*alpha.z;
if (IN.position.x<-0.3) IN.position.z+=fx2*alpha.z;
}
*/
//IN.position.z+=1*IN.position.y*alpha.z;




    IN.normal=mul((float3x3   )ModelViewObject,IN.normal);
IN.tangent=mul((float3x3   )ModelViewObject,IN.tangent);
   
    OUT.HPOS = mul(ModelViewProj, IN.position);
    OUT.oUV=IN.uvs;

//    OUT.oPosition=mul (ModelViewLightProj,IN.position);


    //IN.position=mul(IN.position, ModelViewObject);
    //IN.normal=mul(IN.normal,(float3x3   )ModelViewObject);
//IN.tangent=mul(IN.tangent,(float3x3   )ModelViewObject);
//IN.position.w=0;


float3 LightP=LightPos;

float3 L=normalize (LightP-IN.position);
float3 V=normalize (CameraPos-IN.position);
float3 H=normalize (L+V);
float4 AllWhite=float4 (0.2,0.7,1,0);

//float specularL=pow (max(dot (IN.normal,H),0),14);
//float diff=max (dot (IN.normal,L),0);

// spherical mapping
float m;

m=1-max (dot (IN.normal,V),0);
m*=m*0.6;
m+=0.1;
//float m=2*sqrt(ref.x*ref.x)l

//m = 2(fx^2 + fy^2 + (fz + 1)^2)^(1/2). 

 //OUT.oUV=float2 (m,m);
 //ref.x/m+0.5,ref.y/m+0.5);
 //reflect (V,IN.normal);



OUT.oLight=(-IN.position+LightP*1);
OUT.oNormal=IN.normal;
//OUT.oLight=H;

//normalize(IN.position-LightP);

//OUT.oNormal=
//OUT.oPos=IN.position;

//diff=pow(diff,1);

float3 binormal = cross(IN.normal,IN.tangent);


float3x3 rotation = float3x3(IN.tangent,                               binormal,                               IN.normal);
 rotation = float3x3(IN.tangent,
     binormal,
     IN.normal);
 
//float ff=length(LightP);
float len=length(CameraPos-IN.position);
float mult=1/(1+0.0008*len*len);
//mult*=mult*3.5;

/*
OUT.oLight = mul(rotation, OUT.oLight);
OUT.oLight=normalize(OUT.oLight);
OUT.oLight=float3(0,0,-1);
*/
OUT.oHalf=mul(rotation,H);
OUT.oHalf=normalize(OUT.oHalf);


float mx=max (0,dot(OUT.oNormal,OUT.oHalf));
mx=0.015*pow(mx+0.7,30);
mx=min (1,mx);

//OUT.HCOL=IN.diffuse*float4(m,m,m,m);
OUT.HCOL2=float4(m,m,m,m)*mult*IN.diffuse+0.1+0.3*mx*float4 (1,0.0,0,0);

//OUT.HCOL=AllWhite;
//OUT.HCOL2=AllWhite;


//OUT.HCOL=float4 (1,1,1,1);

//if (LightP.x<111110) OUT.HCOL.x=1;

//float g=IN.color.x;
/*
OUT.HCOL.x=0.1+diff*0.7;
OUT.HCOL.y=0.1+diff*0.9;
OUT.HCOL.z=0.1+diff*1.9;
*/

    return OUT;
} // main




























/*


  VERTEX ENV MAP



  
struct appdata
{
    float4 position : POSITION;
    float3 normal : NORMAL;
    float3 color : DIFFUSE;
    float3 TestColor : SPECULAR;
};

struct vfconn
{
    float4 HPOS : POSITION;
    float2 oPosition : TEXCOORD0;
    float2 oNormal : TEXCOORD1;
};

vfconn main(appdata IN,
            uniform float3 Kd,
            uniform float4x4 ModelViewProj)
{
    vfconn OUT;

    

	OUT.HPOS = mul(ModelViewProj, IN.position);
float3 normal=mul((float3x3)ModelViewProj,IN.normal);
normalize(normal);


float4 normpos=normalize(OUT.HPOS);
float3 refl=reflect (normal,normpos);


float magn=1.5*sqrt (refl.x*refl.x+refl.y*refl.y+(refl.z+1)*(refl.z+1));






float4 normpos2=normalize(IN.position);
float3 refl2=reflect (IN.normal,normpos);


float magn2=1.5*sqrt (refl2.x*refl2.x+refl2.y*refl2.y+(refl2.z+1)*(refl2.z+1));




//diss/=length(diss);


//float cl=dot (normal,diss-OUT.HPOS);
OUT.oNormal.x=refl.x/magn+0.5;
OUT.oNormal.y=refl.y/magn+0.5;


//normalize(diss);

OUT.oPosition.x=IN.position.x*2;
OUT.oPosition.y=IN.position.y*2;

//OUT.oNormal.x=normal.x*0.3;
//OUT.oNormal.y=normal.y*0.3;

    return OUT;
} // main

 */
